//数据常用类
function getArrayDataById(sourceData){

}

function getArrayDataByObject(sourceData,selectObject){
    for (var i=0;i<sourceData.length;i++){
        var currentObj = sourceData[i];
        if(currentObj == selectObject){
            return currentObj;
        }
    }
}
//根据数据属性名属性值获得Object
function getArrayDataByAttribute(sourceData,attributeName,attributeValue){
    for (var i=0;i<sourceData.length;i++){
        var currentObj = sourceData[i];
        if(currentObj[attributeName] == attributeValue){
            return currentObj;
        }
    }
}

function getWhereInConditionByJson(JsonString,attributeName){
    var json = JSON.parse(JsonString);
    var searchWhereStr = "";
    for (var i = 0;i<json.length;i++){
        searchWhereStr += "'"+json[i][attributeName]+"',";
    }
    if(json.length >0){
        searchWhereStr = " "+ attributeName +"  IN ("+searchWhereStr.substr(0,searchWhereStr.length-1)+")";
    }
    return searchWhereStr;
}

function getWhereInConditionByJsonNoField(JsonString,attributeName){
    var json = JSON.parse(JsonString);
    var searchWhereStr = "";
    for (var i = 0;i<json.length;i++){
        searchWhereStr += "'"+json[i][attributeName]+"',";
    }
    if(json.length >0){
        searchWhereStr = "   IN ("+searchWhereStr.substr(0,searchWhereStr.length-1)+")";
    }
    return searchWhereStr;
}

//Where IN 条件读取
function getWhereInConditionByArray(sourceData,attributeName){
    var returnStr = "";
    for (var i=0;i<sourceData.length;i++){
        returnStr += "'"+sourceData[i][attributeName]+"',";
    }
    if(sourceData.length >0){
        returnStr = " and OBJECTID IN ("+returnStr.substr(0,returnStr.length-1)+")";
    }
    return returnStr;
}

//判断数据是否为空
function isEmptyValue(value) {
    var type;
    if(value == null) { // 等同于 value === undefined || value === null
        return true;
    }
    if(value == "null"){
        return true;
    }
    type = Object.prototype.toString.call(value).slice(8, -1);
    switch(type) {
        case 'String':
            return !$.trim(value);
        case 'Array':
            return !value.length;
        case 'Object':
            return $.isEmptyObject(value); // 普通对象使用 for...in 判断，有 key 即为 false
        default:
            return false; // 其他对象均视作非空
    }
}

function convertWebserviceResultToArray(){

}

//图层查询结果转换为数组
function convertMapQueryResultToArray(graphics){
    var returnArray = [];
    var returnNames = [];
    for(var i = 0; i < graphics.length; i++) {
        var attributes = graphics[i].attributes;
        var addObj = new Object();
        for (var tempObj in attributes){
            addObj[tempObj] = attributes[tempObj];
        }
        addObj.graphic = graphics[i];
        if(contains(returnNames,attributes.项目名称) == false){
            returnNames.push(attributes.项目名称);
            returnArray.push(addObj);
        }
    }
    return returnArray;
}

function convertMapQueryResultToArray1(graphics){
    var returnArray = [];
    for(var i = 0; i < graphics.length; i++) {
        var attributes = graphics[i].attributes;
        var addObj = new Object();
        for (var tempObj in attributes){
            addObj[tempObj] = attributes[tempObj];
        }
        addObj.graphic = graphics[i];
        returnArray.push(addObj);
    }
    return returnArray;
}

function contains(arr, obj) {
    var i = arr.length;
    while (i--) {
        if (arr[i] === obj) {
            return true;
        }
    }
    return false;
}

//判断数组中是否包含object数据
function containsPartObject(arr, obj){
    var i = arr.length;
    while (i--) {
        var matchCount = 0;
        var sourceCount = 0;
        for (var objnamechildnode in obj){
            sourceCount ++;
        }
        for (var objName in arr[i]){
            var key = objName;
            var value = arr[i][objName];
            for (var objNameChild in obj){
                var keyChild = objNameChild;
                var valueChild = obj[keyChild]
                if(key == keyChild && value == valueChild){
                    matchCount ++;
                }
            }
        }
        if(matchCount == sourceCount ){
            return true;
        }
    }
    return false;
}

//扩展对象的count方法
// Object.prototype.count = (
//     Object.prototype.hasOwnProperty('__count__')
// ) ? function () {
//     return this.__count__;
// } : function () {
//     var count = 0;
//     for (var i in this) if (this.hasOwnProperty(i)) {
//         count ++;
//     }
//     return count;
// };

//Json转换为Array
function convertJsonToArray(JsonString){
    var json = JSON.parse(JsonString);
    return json;
}

//删除重复数据
function unique(arr) {
    var result = [], isRepeated;
    for (var i = 0 ; i < arr.length; i++) {
        isRepeated = false;
        for (var j = 0 ; j < result.length; j++) {
            if (arr[i] == result[j]) {
                isRepeated = true;
                break;
            }
        }
        if (!isRepeated) {
            result.push(arr[i]);
        }
    }
    return result;
}

//遍历Object示例
function foreachObject(Object){
    for (var objName in Object){
        var key = objName;
        var value = Object[objName];
    }
}

function getDate() {
    var date = new Date();
    var month = date.getMonth() + 1;
    var day = date.getDate();
    return date.getFullYear() + '-' + getFormatDate(month) + '-' + getFormatDate(day);
}

function getDateTime() {
    var date = new Date();
    var month = date.getMonth() + 1;
    var day = date.getDate();
    return date.getFullYear() +  getFormatDate(month) + getFormatDate(day)+date.getHours()+date.getMinutes()+date.getMilliseconds();
}

// 日期，在原有日期基础上，增加days天数，默认增加1天
function addDate(date, days) {
    if (days == undefined || days == '') {
        days = 1;
    }
    var date = new Date(date);
    date.setDate(date.getDate() + days);
    var month = date.getMonth() + 1;
    var day = date.getDate();
    return date.getFullYear() + '-' + getFormatDate(month) + '-' + getFormatDate(day);
}

// 日期月份/天的显示，如果是1位数，则在前面加上'0'
function getFormatDate(arg) {
    if (arg == undefined || arg == '') {
        return '';
    }

    var re = arg + '';
    if (re.length < 2) {
        re = '0' + re;
    }

    return re;
}

//返回星期几
function getDateWeekday(date) {
    var str = "周";
    var week = new Date(date).getDay();
    switch (week) {
        case 0 :
            str += "日";
            break;
        case 1 :
            str += "一";
            break;
        case 2 :
            str += "二";
            break;
        case 3 :
            str += "三";
            break;
        case 4 :
            str += "四";
            break;
        case 5 :
            str += "五";
            break;
        case 6 :
            str += "六";
            break;
    }
    return str;
}

//传参
function GetQueryString(name)
{
    var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
    var r = window.location.search.substr(1).match(reg);
    if(r!=null)return  decodeURI(r[2]); return null;
}

var dateControlInitDate;
var dateControlLimitDate;
function initDateControl(yearControlName,monthControlName,dayControlName,initDate,limitDays) {
    var date;
    var limitDate;
    var maxday=30;
    if(initDate){
        date=new Date(initDate);
    }else{
        date= new Date();
    }
    dateControlInitDate=date;
    if(limitDays){
        limitDate= new Date(date);
        limitDate.setDate(date.getDate() + limitDays);
        dateControlLimitDate=new Date(limitDate);
    }
    else{
        dateControlLimitDate=null;
    }
    $("#"+yearControlName).html("");
    $("#"+monthControlName).html("");
    $("#"+dayControlName).html("");
    var year = date.getFullYear();//年
    var month = date.getMonth();//月
    var day = date.getDate();//日
    var optionStr="";
    if(limitDate){
        var limityear = limitDate.getFullYear();//年
        var limitmonth = limitDate.getMonth();//月
        var limitday = limitDate.getDate();//日
        if(year==limityear){
            optionStr+="<option value='"+year+"'>"+year+"</option>";
        }else{
            optionStr+="<option value='"+year+"'>"+year+"</option>";
            optionStr+="<option value='"+limityear+"'>"+limityear+"</option>";
        }
        $("#"+yearControlName).html(optionStr);
        $("#"+yearControlName).val(year);
        optionStr="";
        month++;
        limitmonth++;
        if(month==limitmonth){
            optionStr+="<option value='"+getFormatDate(month)+"'>"+month+"</option>";
        }else{
            optionStr+="<option value='"+getFormatDate(month)+"'>"+month+"</option>";
            optionStr+="<option value='"+getFormatDate(limitmonth)+"'>"+limitmonth+"</option>";
        }
        $("#"+monthControlName).html(optionStr);
        $("#"+monthControlName).val(getFormatDate(month));
        optionStr="";
        if(month<8){
            if(month==2){
                if(year%4==0){
                    maxday=29;
                }else{
                    maxday=28;
                }
            }else
            {
                if(month%2==1){
                    maxday=31;
                }
            }
        }else{
            if(month%2==0){
                maxday=31;
            }
        }
        if(day>limitday){
            for(var i=day;i<=maxday;i++){
                optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
            }
        }else{
            for(var i=day;i<=limitday;i++){
                optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
            }
        }

        $("#"+dayControlName).html(optionStr);
        $("#"+dayControlName).val(getFormatDate(day));
    }
    else{
        for(var i=-1;i<3;i++){
            var opYear=year+i;
            optionStr+="<option value='"+opYear+"'>"+opYear+"</option>";
        }
        $("#"+yearControlName).html(optionStr);
        $("#"+yearControlName).val(year);
        optionStr="";
        month++;
        for(var i=1;i<=12;i++){
            optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
        }
        $("#"+monthControlName).html(optionStr);
        $("#"+monthControlName).val(getFormatDate(month));
        optionStr="";
        if(month<8){
            if(month==2){
                if(year%4==0){
                    maxday=29;
                }else{
                    maxday=28;
                }
            }else
            {
                if(month%2==1){
                    maxday=31;
                }
            }
        }else{
            if(month%2==0){
                maxday=31;
            }
        }
        for(var i=1;i<=maxday;i++){
            optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
        }
        $("#"+dayControlName).html(optionStr);
        $("#"+dayControlName).val(getFormatDate(day));
    }

}

function yearControlChange() {
    if(dateControlLimitDate){

    }else{

    }
}

function monthControlChange(control,dayControlName) {
    var year;
    var month;
    var day;
    var limitday;
    var limitMonth;
    var maxday=30;
    var optionStr="";
    if(dateControlLimitDate){
        year=dateControlLimitDate.getFullYear();
        month=dateControlInitDate.getMonth();
        day=dateControlInitDate.getDate();
        month++;
        limitMonth=dateControlLimitDate.getMonth();
        limitMonth++;
        limitday=dateControlLimitDate.getDate();
        if(parseInt($("#"+control.id).val())==limitMonth){
            if(limitMonth<8){
                if(limitMonth==2){
                    if(year%4==0){
                        maxday=29;
                    }else{
                        maxday=28;
                    }
                }else
                {
                    if(limitMonth%2==1){
                        maxday=31;
                    }
                }
            }else{
                if(limitMonth%2==0){
                    maxday=31;
                }
            }
            if(day>limitday){
                for(var i=1;i<=limitday;i++){
                    optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
                }
            }else{
                for(var i=day;i<=limitday;i++){
                    optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
                }
            }

            $("#"+dayControlName).html(optionStr);
            $("#"+dayControlName).val(getFormatDate(day));
        }else{
            if(month<8){
                if(month==2){
                    if(year%4==0){
                        maxday=29;
                    }else{
                        maxday=28;
                    }
                }else
                {
                    if(month%2==1){
                        maxday=31;
                    }
                }
            }else{
                if(month%2==0){
                    maxday=31;
                }
            }
            if(day>limitday){
                for(var i=day;i<=maxday;i++){
                    optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
                }
            }else{
                for(var i=day;i<=limitday;i++){
                    optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
                }
            }

            $("#"+dayControlName).html(optionStr);
            $("#"+dayControlName).val(getFormatDate(day));
        }
    }else{
        year=dateControlInitDate.getFullYear();
        month=parseInt($("#"+control.id).val());
        optionStr="";
        if(month<8){
            if(month==2){
                if(year%4==0){
                    maxday=29;
                }else{
                    maxday=28;
                }
            }else
            {
                if(month%2==1){
                    maxday=31;
                }
            }
        }else{
            if(month%2==0){
                maxday=31;
            }
        }
        for(var i=1;i<=maxday;i++){
            optionStr+="<option value='"+getFormatDate(i)+"'>"+i+"</option>";
        }
        $("#"+dayControlName).html(optionStr);
    }
}

function dayControlChange() {
    if(dateControlLimitDate){

    }else{

    }
}

function TimestampToDate(Timestamp) {
    let date1 = new Date(Timestamp);
    return date1.toLocaleDateString().replace(/\//g, "-") + " " + date1.toTimeString().substr(0, 8);
}

function TimestampToDate2(Timestamp) {
    let now = new Date(Timestamp),
        y = now.getFullYear(),
        m = now.getMonth() + 1,
        d = now.getDate();
    return y + "-" + (m < 10 ? "0" + m : m) + "-" + (d < 10 ? "0" + d : d) + " " + now.toTimeString().substr(0, 8);
}


function DateToTimestamp(date) {
    return Number(date);
}

function DateToTimestamp2(dateString) {
    let d=new Date(dateString.replace(/-/g,"/"));
    return DateToTimestamp(d);
}

function AntiSqlValid(oField )
{
    let re= /select|update|delete|exec|count|'|"|=|;|>|<|%/i;
    if (re.test(oField.value) )
    {
        alert("请您不要在参数中输入特殊字符和SQL关键字！"); //注意中文乱码
        oField.value ='';
        oField.className="errInfo";
        oField.focus();
        return false;
    }
}
