let acProject;
let acHouse;
let acHouseSub;
let pageSize=5;
function taskQueryProjectSucess(evt,keyValue,extraData) {
    var allCount;
    var pageIndex;
    var msg;
    var jsonArray;
    var currentCount;

    if (evt!= null) {
        allCount = evt.AllCount;
        pageIndex = evt.pageIndex;
        jsonArray = evt.data;
        currentCount=evt.CurrCount;
        msg=evt.Msg;
    }
    switch (keyValue) {
        case "queryStreetById":{
            let returnGraphicArray=[];
            acProject=jsonArray;
            $("#tabResult li:eq(0) a").tab('show');
            //显示记录
            $("#divDataListProject").html('');
            let listgroup=document.createElement("ul");
            $(listgroup).addClass("list-group");
            for(let i=0;i<jsonArray.length;i++){
                let divItem=document.createElement("li");
                $(divItem).addClass("list-group-item");
                $(divItem).on("click",function () {
                    showStreetHospital(jsonArray[i].estate_project_id);
                    positionStreet(jsonArray[i].estate_project_id);
                });
                let divItemStr=jsonArray[i].project_name+"<span class='badge'>"+jsonArray[i].房屋数量+"</span>"
                $(divItem).html(divItemStr);
                $(listgroup).append(divItem);
            }
            $("#divDataListProject").append(listgroup);
            //定位项目
            for(let i=0;i<acProject.length;i++){
                let geom=GetGeomtryFormPostgis(JSON.parse(jsonArray[i].geomt));
                returnGraphicArray.push(createGraphic(geom,jsonArray[i]));
            }
            GraphicsLayer_myLayer.removeAll();
            AddGraphicDataToGraphicLayer(jsonArray,GraphicsLayer_myLayer);
            break;
        }
        case "positionStreet":{
            let returnGraphicArray=[];
            for(let i=0;i<jsonArray.length;i++){
                if(jsonArray[i].geomt){
                    let geom=GetGeomtryFormPostgis(JSON.parse(jsonArray[i].geomt));
                    returnGraphicArray.push(createGraphic(geom,jsonArray[i]));
                }

            }
            GraphicsLayer_myLayer.removeAll();
            AddGraphicDataToGraphicLayer(jsonArray,GraphicsLayer_myLayer);
            break;
        }
        case "queryBuildingById":{
            let returnGraphicArray=[];
            for(let i=0;i<jsonArray.length;i++){
                if(jsonArray[i].geomt){
                    let geom=GetGeomtryFormPostgis(JSON.parse(jsonArray[i].geomt));

                    returnGraphicArray.push(createGraphic(geom,jsonArray[i]));
                }
            }
            GraphicsLayer_myLayer.removeAll();
            AddGraphicDataToGraphicLayer(jsonArray,GraphicsLayer_myLayer);
            break;
        }
        case "queryBuildingByProjectId":{
            if(extraData){
                let optionStr="";
                $.each(jsonArray,function (index,json){
                    optionStr+="<option value='"+json.building_id+"'>"+json.building_name+"</option>";
                });
                optionStr=optionStr+"<option value='-1'>全部楼栋</option>";
                $("#"+extraData).html(optionStr);
            }
            break;
        }
        case "queryBuildingByHouseId":{
            let returnGraphicArray=[];
            for(let i=0;i<jsonArray.length;i++){
                if(jsonArray[i].geomt){
                    let geom=GetGeomtryFormPostgis(JSON.parse(jsonArray[i].geomt));
                    returnGraphicArray.push(createGraphic(geom,jsonArray[i]));
                }
                $("#hidBuildingId").val(jsonArray[i].building_id);
            }
            GraphicsLayer_myLayer.removeAll();
            AddGraphicDataToGraphicLayer(jsonArray,GraphicsLayer_myLayer);
            break;
        }
        case "positionHospital":{
            let returnGraphicArray=[];
            for(let i=0;i<jsonArray.length;i++){
                if(jsonArray[i].geomt){
                    let geom=GetGeomtryFormPostgis(JSON.parse(jsonArray[i].geomt));

                    returnGraphicArray.push(createGraphic(geom,jsonArray[i]));
                }
            }
            GraphicsLayer_myLayer.addMany(returnGraphicArray);
            //AddGraphicDataToGraphicLayer(returnGraphicArray,GraphicsLayer_myLayer);
            break;
        }
        case "updateProjectGeomById":{
            alert("已保存项目范围")
            break;
        }
        case "updateHouseGeomById":{
            alert("已保存房屋位置");
            break;
        }
        case "updateBuildingGeomById":{
            alert("已保存楼栋位置");
            if(extraData){
                queryBuildingById(extraData);
            }
            break;
        }
        case "queryStreetByWhere":{
            let returnGraphicArray=[];
            let popsArray=[];
            popupCloseAll();
            for(let i=0;i<jsonArray.length;i++){
                let geom=GetGeomtryFormPostgis(JSON.parse(jsonArray[i].geomt));
                var content="<label value='"+i+"' onclick='showInfoDetail("+i+")'>"+
                    ""+jsonArray[i].街道名称+" ("+jsonArray[i].所属区县+")</label>";
                popsArray.push({
                    //地图坐标
                    x: geom.x,
                    y: geom.y,
                    //popup内容的文字，只是个示范，当然格式不限
                    content: content,
                    //气泡窗口div的id唯一标识
                    id:"info"+i
                });
                returnGraphicArray.push(createGraphic(geom,jsonArray[i]));
            }
            GraphicsLayer_myLayer.removeAll();
            //popupInit(popsArray,1);
            arrayProject=returnGraphicArray;
            AddGraphicDataToGraphicLayer(jsonArray,GraphicsLayer_myLayer);
            break;
        }
        case "getHospitalType":{
            let optionStr="";
            $.each(jsonArray,function (index,json){
                optionStr+="<option value='"+json.id+"'>"+json.类型+"</option>";
            });
            optionStr="<option value='-1'>全部类型</option>"+optionStr;
            $("#ddlHospitalType").html(optionStr);
            break;
        }
        case "getEmuStreetName":{
            let optionStr="";
            $.each(jsonArray,function (index,json){
                optionStr+="<option value='"+json.街道名称+"'>"+json.街道名称+"</option>";
            });
            optionStr="<option value='-1'>全部街镇</option>"+optionStr;
            $("#ddlJd").html(optionStr);
            break;
        }
        case "getEmuQuName":{
            let optionStr="";
            $.each(jsonArray,function (index,json){
                optionStr+="<option value='"+json.所属区县+"'>"+json.所属区县+"</option>";
            });
            optionStr="<option value='-1'>全部区县</option>"+optionStr;
            $("#ddlQu").html(optionStr);
            break;
        }
        case "searchHospital":{
            acHouse=jsonArray;
            GraphicsLayer_fickerLayer.removeAll();
            GraphicsLayer_labelLayer.removeAll();
            if(acHouse.length>0){
                let totalPage;
                if(Math.floor(acHouse.length%pageSize)==0){
                    totalPage=Math.floor(acHouse.length/pageSize);
                }else {
                    totalPage=Math.floor(acHouse.length/pageSize)+1;
                }

                var pageInner="<li><a>计&nbsp;"+acHouse.length+"&nbsp;条记录，共&nbsp;"+totalPage+"&nbsp;页</a></li>" +
                    "<li><a href=\"javascript:btPreDataListHouse();\">&laquo;</a></li>";
                for(var i=0;i<totalPage;i++){
                    pageInner+="<li class='page1'><a href=\"javascript:btDataListHouse("+(i+1)+");\">"+(i+1)+"</a></li>";
                }
                pageInner+="<li><a href=\"javascript:btNextDataListHouse();\">&raquo;</a></li>";
                $("#divDataListHousePage").html(pageInner);
            }else{
                $("#divDataListHouse").html('');
                $("#divDataListHousePage").html('');
            }
            //房屋（楼栋）撒点
            var returnGraphicArray=[];
            for(let i=0;i<acHouse.length;i++){
                if(jsonArray[i].geomt){
                    let geom=GetGeomtryFormPostgis(JSON.parse(acHouse[i].geomt));
                    let symbol1={
                        type:"picture-marker",
                        url:"assets/images/"+acHouse[i].type_+".png",
                        size:"24px"
                    };
                    let template={
                        title:"{org_name}",
                        content:[{
                            type:"fields",
                            fieldInfos:[{
                                fieldName:"org_addres",
                                label:"地址"
                            }]
                        }]
                    }
                    returnGraphicArray.push(createGraphic(geom,jsonArray[i],symbol1,template));
                }

            }
            //GraphicsLayer_myLayer.removeAll();
            GraphicsLayer_labelLayer.addMany(returnGraphicArray);
            btDataListHouse(1);
            break;
        }
        case "searchHospitalStreet":{
            acHouse=jsonArray;
            //$("#collapseOne").collapse("hide");
            $("#divDataListProject").html('');
            let listgroup=document.createElement("ul");
            $(listgroup).addClass("list-group");
            for(let i=0;i<jsonArray.length;i++){
                let divItem=document.createElement("li");
                $(divItem).addClass("list-group-item");
                $(divItem).on("click",function () {
                    showStreetHospital(jsonArray[i].estate_project_id);
                    //定位项目
                    positionStreet(jsonArray[i].estate_project_id);
                });
                let divItemStr=jsonArray[i].org_name+"<span class='badge'>"+jsonArray[i].type_name+"</span>"
                $(divItem).html(divItemStr);
                $(listgroup).append(divItem);
            }
            $("#divDataListProject").append(listgroup);
            break;
        }
    }//switch
}

//---------------- 街道乡镇 ----------------------------------

//修改项目图形
function updateProjectGeomById(projectId,geomText) {
    var sql="update estate_project set geom=st_geomfromtext('"+geomText+"') where estate_project_id='"+projectId+"'";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"updateProjectGeomById");
}

//项目id查项目信息
function queryStreetById(projectId) {
    var sql="select t.*,st_asgeojson(t.geom) as geomt,a.房屋数量 from estate_project t" +
        " join(select estate_project_id,count(estate_project_id) as 房屋数量 from house where estate_project_id='"+projectId+"' group by estate_project_id) a on a.estate_project_id=t.estate_project_id" +
        " where t.estate_project_id='"+projectId+"'";

    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"queryStreetById");
}

//通过项目id定位项目
function positionStreet(projectId) {
    let sql="select a.*,st_asgeojson(a.geom) as geomt from estate_project a where a.estate_project_id='"+projectId+"'";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"positionStreet");
}

//得到所有项目列表和项目点
function queryStreetByWhere(whereString) {
    let sql="select t.*,st_asgeojson(t.geom) as geomt from jdxz84 t where 1=1 ";
    if(whereString){
        sql+=" and "+whereString;
    }
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"queryStreetByWhere");
}

function getEmuQuName(){
    let sql="select 所属区县 from jdxz84 group by 所属区县";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"getEmuQuName",false);
}

//得到所有项目名称及id
function getEmuStreetName(QuName){
    if(QuName!="-1"){
        let sql="select * from jdxz84 where 所属区县='"+QuName+"'";
        new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"getEmuStreetName",false);
    }else{
        let optionStr="<option value='-1'>全部街镇</option>";
        $("#ddlJd").html(optionStr);
    }

}

//----------------- 楼栋 ---------------------------------
function queryBuildingById(buildingId) {
    let sql="select t.*,st_asgeojson(t.geom) as geomt from building t where building_id='"+buildingId+"'";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"queryBuildingById");
}

function queryBuildingByProjectId(projectId,controlName){
    if(parseInt(projectId)>0){
        let sql="select t.*,st_asgeojson(t.geom) as geomt from building t where estate_project_id='"+projectId+"'";
        new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"queryBuildingByProjectId",false,controlName);
    }else{
        let optionStr="<option value='-1'>全部楼栋</option>";
        $("#"+controlName).html(optionStr);
    }

}

//通过房屋id查楼栋
function queryBuildingByHouseId(houseId){
    let sql="select t.*,st_asgeojson(t.geom) as geomt from building t" +
        " where t.building_id =(select h.building_id from house h where h.house_id='"+houseId+"')";

    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"queryBuildingByHouseId");
}

//修改楼栋位置（图形）
function updateBuildingGeomById(buildingId,geomText) {
    let sql="update building set geom=st_geomfromtext('"+geomText+"') where building_id='"+buildingId+"'";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"updateBuildingGeomById",false,buildingId);
}
//修改楼栋位置（图形）
function updateBuildingGeomByHouseId(houseId,geomText) {
    let sql="update building set geom=st_geomfromtext('"+geomText+"') where building_id=(select building_id from house where house_id='"+houseId+"')";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"updateBuildingGeomById");
}



//------------------ 服务机构  -------------------------------

//从acHouse(array)中筛选
function showStreetHospital(projectId) {
    let resultsArray=[];
    $.each(acHouse,function (index,json) {
        if(json.estate_project_id==projectId){
            resultsArray.push(json);
        }
    });
    acHouseSub=resultsArray;
    if(acHouseSub.length>0){
        let totalPage;
        if(Math.floor(acHouseSub.length%10)==0){
            totalPage=Math.floor(acHouseSub.length/10);
        }else {
            totalPage=Math.floor(acHouseSub.length/10)+1;
        }

        var pageInner="<li><a>计&nbsp;"+acHouseSub.length+"&nbsp;条记录，共&nbsp;"+totalPage+"&nbsp;页</a></li>" +
            "<li><a href=\"javascript:btPreDataListHouse2();\">&laquo;</a></li>";
        for(var i=0;i<totalPage;i++){
            pageInner+="<li class='page1'><a href=\"javascript:btDataListHouse2("+(i+1)+");\">"+(i+1)+"</a></li>";
        }
        pageInner+="<li><a href=\"javascript:btNextDataListHouse2();\">&raquo;</a></li>";
        $("#divDataListHousePage").html(pageInner);
    }else{
        $("#divDataListHouse").html('');
        $("#divDataListHousePage").html('');
    }
    btDataListHouse2(1,resultsArray);
    $("#tabResult li:eq(1) a").tab('show');
    // $("#divDataListHouse").html('');
    // $("#divDataListHouse").CreateTableByColumns({
    //         head:["栋号","室号","套内面积","户型","状态"],
    //         data:resultsArray,
    //         columns:["building_no","room_no","house_area","house_type","house_state_name"]
    //     }
    // );
    positionHospital(resultsArray);
}

//修改房屋位置（图形）
function updateHouseGeomById(houseId,geomText) {
    let sql="update house set geom=st_geomfromtext('"+geomText+"') where house_id='"+houseId+"'";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"updateHouseGeomById");
}

//得到服务机构类型
function getHospitalType() {
    let sql="select * from org_type";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"getHospitalType",true);
}

function positionHospital(houseArray) {
    let ids="";
    for(let i=0;i<houseArray.length>0;i++){
        let graphic;
        for(let j=0;j<GraphicsLayer_labelLayer.graphics.items.length;j++){
            if(GraphicsLayer_labelLayer.graphics.items[j].attributes.gid==houseArray[i]){
                graphic=GraphicsLayer_labelLayer.graphics.items[j];
                break;
            }
        }
        highlightGraphic(GraphicsLayer_labelLayer,graphic);
        m_view.goTo(graphic);
        m_view.popup.open({
            features:[graphic],
            location:graphic.geometry,
        });
        m_view.zoom=15;
    }
    if(ids.length>0){
        ids=ids.substr(0,ids.length-1);
    }
    let sql="select *,st_asgeojson(t.geom) as geomt from house t where house_id in("+ids+")";
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"positionHospital");
}

//---------------------------------- 页面其他 ---------------------------
//搜索
function searchHospital() {
    m_view.popup.close();
    let whereString="";
    //1.区县
    if( $("#ddlQu").val()!="-1"){
        whereString+=" and 所属区='"+$("#ddlQu").val()+"'";
    }
    //2.街道
    if( $("#ddlJd").val()!="-1"){
        whereString+=" and 街道名='"+$("#ddlJd").val()+"'";
    }
    //3.类型
    if( $("#ddlHospitalType").val()!="-1"){
        whereString+=" and type_='"+$("#ddlHospitalType").val()+"'";
    }
    //4.搜索
    let sql="select h.*,t.类型 as type_name,st_asgeojson(h.geom) as geomt from fwjg84 h" +
        " join org_type t on h.type_=t.id" +
        " where 1=1 "+whereString;
    new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"searchHospital",true);


}

function searchHospitalStreet() {
    m_view.popup.close();
    let whereString="";
    //1.关键字查询
    let key=$("#txtSearchKey").val().toString().trim();

    if(key.length>0){
        let sql="select h.*,t.类型 as type_name,st_asgeojson(h.geom) as geomt from fwjg84 h" +
            " join org_type t on h.type_=t.id" +
            " where org_name like '%"+key+"%' or org_addres like '%"+key+"%'";
        new WsCommonClass("QueryDataBaseJson",["sql"],[sql],taskQueryProjectSucess,"searchHospital",true);
        clearSearchSelect();
    }else{
        alert("请输入查询条件");
    }
}

//复原搜索条件
function clearSearchSelect() {
    $("#ddlHospitalType").val("-1");
    $("#ddlQu").val("-1");
    ddlQu_change();
}

function btDataListHouse(pageIndex,dataSource){
    let devArray1;
    if(dataSource){
        devArray1=dataSource;
    }else{
        devArray1=getDataListHouse(pageIndex);
    }

    $("#divDataListHouse").html('');
    let listgroup=document.createElement("ul");
    $(listgroup).addClass("list-group");
    for(let i=0;i<devArray1.length;i++){
        let divItem=document.createElement("li");
        $(divItem).addClass("list-group-item");
        $(divItem).attr("data",devArray1[i].gid);
        $(divItem).on("click",function () {
            //定位项目
            positionHospital([devArray1[i].gid]);
        });
        let divItemStr=devArray1[i].org_name+"<span class='label label-success'>"+devArray1[i].type_name+"</span>"
        $(divItem).html(divItemStr);
        $(listgroup).append(divItem);
    }
    $("#divDataListHouse").append(listgroup);
    $("#divDataListHousePage .active").addClass("page1");
    $("#divDataListHousePage li").removeClass("active");
    $("#divDataListHousePage li:eq("+(pageIndex+1)+")").removeClass("page1");
    $("#divDataListHousePage li:eq("+(pageIndex+1)+")").addClass("active");

}

function btDataListHouse2(pageIndex){
    devArray1=getDataListHouse2(pageIndex);

    $("#divDataListHouse").html('');
    $("#divDataListHouse").CreateTableByColumns({
            head:["栋号","室号","套内面积","户型","状态"],
            data:devArray1,
            columns:["building_no","room_no","house_area","house_type","house_state_name"]
        }
    );
    $("#divDataListHousePage .active").addClass("page1");
    $("#divDataListHousePage li").removeClass("active");
    $("#divDataListHousePage li:eq("+(pageIndex+1)+")").removeClass("page1");
    $("#divDataListHousePage li:eq("+(pageIndex+1)+")").addClass("active");
    $("#divDataListHouse tr").on("click",function (event){
        GraphicsLayer_fickerLayer.removeAll();
        let jsonStr = $(event.currentTarget).attr("jsonData");
        let data=JSON.parse(jsonStr);
        let geom=GetGeomtryFormPostgis(JSON.parse(data.geomt));
        let symbol1={
            type:"simple-marker",
            style:"circle",
            size:"12px",
            color:[255,255,0,0.8]
        };
        let graphic=createGraphic(geom,data,symbol1);
        GraphicsLayer_fickerLayer.add(graphic);
        m_view.goTo(graphic);
        m_view.zoom=16;
    })
}

function getDataListHouse(pageIndex){
    var dataArray=[];
    if(pageSize*pageIndex>acHouse.length){

        for(var i=pageSize*(pageIndex-1);i<acHouse.length;i++){
            dataArray.push(acHouse[i]);
        }
    }else{
        for(var i=pageSize*(pageIndex-1);i<pageSize*pageIndex;i++){
            dataArray.push(acHouse[i]);
        }
    }

    return dataArray;
}

function getDataListHouse2(pageIndex){
    var dataArray=[];
    if(10*pageIndex>acHouseSub.length){

        for(var i=10*(pageIndex-1);i<acHouseSub.length;i++){
            dataArray.push(acHouseSub[i]);
        }
    }else{
        for(var i=10*(pageIndex-1);i<10*pageIndex;i++){
            dataArray.push(acHouseSub[i]);
        }
    }

    return dataArray;
}

function btPreDataListHouse() {
    var currentPage=$("#divDataListHousePage .active").text();
    if((parseInt(currentPage)-1)>0){
        btDataListHouse(currentPage-1);
    }
}

function btPreDataListHouse2() {
    var currentPage=$("#divDataListHousePage .active").text();
    if((parseInt(currentPage)-1)>0){
        btDataListHouse2(currentPage-1);
    }
}

function btNextDataListHouse() {
    var currentPage=$("#divDataListHousePage .active").text();
    var totalPage=$("#divDataListHousePage li").length-3;

    if((parseInt(currentPage)+1)<=totalPage){
        btDataListHouse(parseInt(currentPage)+1);
    }
}

function btNextDataListHouse2() {
    var currentPage=$("#divDataListHousePage .active").text();
    var totalPage=$("#divDataListHousePage li").length-3;

    if((parseInt(currentPage)+1)<=totalPage){
        btDataListHouse2(parseInt(currentPage)+1);
    }
}
