/**
 * Created by hm on 2019/8/22.
 */


$.fn.CreateTableByColumns = function (parameter) {
    var tableOptions = {
        tablehead:parameter.head,
        tabledata:parameter.data,
        columns:parameter.columns,
        extraColumns:parameter.extraColumns,
        extraColumnsType:parameter.extraColumnsType,
        extraColumnsByType:parameter.extraColumnsByType,
        extraColumnsByFun:parameter.extraColumnsByFun,
        trStyleFun:parameter.trStyleFun,
        tdStyleFun:parameter.tdStyleFun,//给td样式
        tdStyleIndex:parameter.tdStyleIndex,// 给列下标为tdStyleIndex的样式，和上面组合用
        checkboxColumns:parameter.checkboxColumns//是否前方包含选择框
    };
    var $div = $(this);

    createTable();

    function createTable(){
        var html = [];
        html.push("<table class='table mytable table-bordered table-hover '>");

        if(!(tableOptions.tablehead == null ||tableOptions.tablehead.length == 0) ){
            html.push("<tr>");
            for(var i=0;i<tableOptions.tablehead.length;i++){
                html.push("<th style='background-color: rgba(6, 54, 129, 0.8);font-size:14px;text-align: center'>"+tableOptions.tablehead[i]+"</th>");
            }
            html.push("</tr>");
        }

        if(!(tableOptions.tabledata == null ||tableOptions.tabledata.length == 0 || tableOptions.columns == null ||tableOptions.columns.length == 0 ) ){
            for(var i=0;i<tableOptions.tabledata.length;i++){

                if(parameter.trStyleFun != null){
                    var result = parameter.trStyleFun(tableOptions.tabledata[i],tableOptions.tabledata);
                    html.push("<tr " +result+  "jsonData='" +JSON.stringify(tableOptions.tabledata[i]).replace(/\" /g, '"')+"'>");
                }else{
                    html.push("<tr jsonData='" +JSON.stringify(tableOptions.tabledata[i]).replace(/\" /g, '"')+"'>");
                }

                if(!(tableOptions.checkboxColumns == null ||tableOptions.checkboxColumns == "false") ){
                    if(tableOptions.checkboxColumns=="checkAll"){
                        html.push("<td style='text-align: center' jsonData='" +JSON.stringify(tableOptions.tabledata[i]).replace(/\" /g, '"') +"'><input type='checkbox' name='ckSelect' checked></td>");
                    }else{
                        html.push("<td style='text-align: center' jsonData='" +JSON.stringify(tableOptions.tabledata[i]).replace(/\" /g, '"') +"'><input type='checkbox' name='ckSelect'></td>");
                    }

                }
                for(var j=0;j<tableOptions.columns.length;j++){
                    if(tableOptions.tdStyleIndex == null){
                        html.push("<td style='text-align: center;'>"+(tableOptions.tabledata[i][tableOptions.columns[j]]?tableOptions.tabledata[i][tableOptions.columns[j]]:"")+"</td>");
                    }else{
                        if(tableOptions.tdStyleIndex==j){
                            var tdFun = parameter.tdStyleFun(tableOptions.tabledata[i],tableOptions.tabledata);
                            html.push("<td style='text-align: center'><u " +tdFun+  ">"+tableOptions.tabledata[i][tableOptions.columns[j]]+"</u></td>");
                        }else{
                            html.push("<td style='text-align: center'>"+tableOptions.tabledata[i][tableOptions.columns[j]]+"</td>");
                        }

                    }

                }

                if(!(tableOptions.extraColumns == null ||tableOptions.extraColumns.length == 0) ){
                    for(var k=0;k<tableOptions.extraColumns.length;k++){
                        html.push("<td style='text-align: center'  jsonData='" +JSON.stringify(tableOptions.tabledata[i]).replace(/\"/g,'"')+   "'>" + tableOptions.extraColumns[k].html + "</td>");
                    }
                }
                if(tableOptions.extraColumnsType != null && tableOptions.extraColumnsByType != null){
                    //debugger;
                    var objColumnsType =  tableOptions.tabledata[i][tableOptions.extraColumnsType];
                    html.push("<td  style='text-align: center' jsonData='" +JSON.stringify(tableOptions.tabledata[i]).replace(/\"/g,'"')+   "'>" + tableOptions.extraColumnsByType[objColumnsType] + "</td>");
                }
                if(parameter.extraColumnsByFun != null){
                    var result = parameter.extraColumnsByFun(tableOptions.tabledata[i])
                    html.push("<td style='text-align: center'  jsonData='" +JSON.stringify(tableOptions.tabledata[i]).replace(/\"/g,'"')+   "'>" + result + "</td>");
                }
                html.push("</tr>");
            }
        }

        html.push("</table>");

        $div.html(html.join(''));
    }

}
